_OS_Init:
;RTOS.mpas,341 :: 		begin
;RTOS.mpas,342 :: 		OS_Timer_IE_bit := 0; // disable the timebase timer interrupts
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,345 :: 		T1IP0_bit     := 0;
LUI	R2, BitMask(T1IP0_bit+0)
ORI	R2, R2, BitMask(T1IP0_bit+0)
_SX	8, Offset(T1IP0_bit+4), 4
;RTOS.mpas,346 :: 		T1IP1_bit     := 0;
LUI	R2, BitMask(T1IP1_bit+0)
ORI	R2, R2, BitMask(T1IP1_bit+0)
_SX	8, Offset(T1IP1_bit+4), 4
;RTOS.mpas,347 :: 		T1IP2_bit     := 0;
LUI	R2, BitMask(T1IP2_bit+0)
ORI	R2, R2, BitMask(T1IP2_bit+0)
_SX	8, Offset(T1IP2_bit+4), 4
;RTOS.mpas,349 :: 		T1IF_bit      := 0;
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+4), 4
;RTOS.mpas,351 :: 		for OS_Init_I := 0 to (OS_TASKS_COUNT - 1)   do TaskData[OS_Init_I]._State := st_DESTROYED;  // remove all tasks from the task list
SB	R0, Offset(RTOS_OS_Init_I+0)(GP)
L__OS_Init2:
LBU	R3, Offset(RTOS_OS_Init_I+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 144
SB	R0, 0(R2)
LBU	R3, Offset(RTOS_OS_Init_I+0)(GP)
ORI	R2, R0, 9
BNE	R3, R2, L__OS_Init293
NOP	
J	L__OS_Init5
NOP	
L__OS_Init293:
LBU	R2, Offset(RTOS_OS_Init_I+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_OS_Init_I+0)(GP)
J	L__OS_Init2
NOP	
L__OS_Init5:
;RTOS.mpas,354 :: 		for OS_Init_I := 0 to (OS_EVENTS_COUNT - 1)  do EventData[OS_Init_I]._Type := et_NOEVENT;    // remove all events from the event list
SB	R0, Offset(RTOS_OS_Init_I+0)(GP)
L__OS_Init7:
LBU	R3, Offset(RTOS_OS_Init_I+0)(GP)
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
SB	R0, 0(R2)
LBU	R3, Offset(RTOS_OS_Init_I+0)(GP)
ORI	R2, R0, 9
BNE	R3, R2, L__OS_Init295
NOP	
J	L__OS_Init10
NOP	
L__OS_Init295:
LBU	R2, Offset(RTOS_OS_Init_I+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_OS_Init_I+0)(GP)
J	L__OS_Init7
NOP	
L__OS_Init10:
;RTOS.mpas,355 :: 		LastEvent := OS_NO_EVENT;
ORI	R2, R0, 255
SB	R2, Offset(RTOS_LastEvent+0)(GP)
;RTOS.mpas,359 :: 		for OS_Init_I := 0 to (OS_PRIORITY_COUNT -1) do LastExecutedTask[OS_Init_I] := OS_NO_TASK;    // remove all entries in the prioritylist
SB	R0, Offset(RTOS_OS_Init_I+0)(GP)
L__OS_Init12:
LBU	R3, Offset(RTOS_OS_Init_I+0)(GP)
LUI	R2, #hi_addr(RTOS_LastExecutedTask+0)
ORI	R2, R2, #lo_addr(RTOS_LastExecutedTask+0)
ADDU	R3, R2, R3
ORI	R2, R0, 255
SB	R2, 0(R3)
LBU	R3, Offset(RTOS_OS_Init_I+0)(GP)
ORI	R2, R0, 9
BNE	R3, R2, L__OS_Init297
NOP	
J	L__OS_Init15
NOP	
L__OS_Init297:
LBU	R2, Offset(RTOS_OS_Init_I+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_OS_Init_I+0)(GP)
J	L__OS_Init12
NOP	
L__OS_Init15:
;RTOS.mpas,360 :: 		LowestPriority := 0;
SB	R0, Offset(RTOS_LowestPriority+0)(GP)
;RTOS.mpas,366 :: 		OS_Idleprocedure := nil; // no idle procedure
SW	R0, Offset(_OS_IdleProcedure+0)(GP)
;RTOS.mpas,369 :: 		CurrentTask    := OS_NO_TASK;
ORI	R2, R0, 255
SB	R2, Offset(RTOS_CurrentTask+0)(GP)
;RTOS.mpas,370 :: 		LastTask       := OS_NO_TASK;
ORI	R2, R0, 255
SB	R2, Offset(RTOS_LastTask+0)(GP)
;RTOS.mpas,372 :: 		end;
L_end_OS_Init:
JR	RA
NOP	
; end of _OS_Init
RTOS_Select_Next_Task:
;RTOS.mpas,383 :: 		begin
;RTOS.mpas,384 :: 		NextTask := OS_NO_TASK;
ORI	R2, R0, 255
SB	R2, Offset(RTOS_NextTask+0)(GP)
;RTOS.mpas,385 :: 		NextTask_Tmp := OS_NO_TASK;
ORI	R2, R0, 255
SB	R2, Offset(RTOS_NextTask_Tmp+0)(GP)
;RTOS.mpas,389 :: 		if LastTask <> OS_NO_TASK then
LBU	R3, Offset(RTOS_LastTask+0)(GP)
ORI	R2, R0, 255
BNE	R3, R2, L_RTOS_Select_Next_Task300
NOP	
J	L_RTOS_Select_Next_Task18
NOP	
L_RTOS_Select_Next_Task300:
;RTOS.mpas,391 :: 		for Priority := 0 to LowestPriority do  // check high to low priorities
SB	R0, Offset(RTOS_Priority+0)(GP)
L_RTOS_Select_Next_Task20:
LBU	R3, Offset(RTOS_LowestPriority+0)(GP)
LBU	R2, Offset(RTOS_Priority+0)(GP)
SLTU	R2, R3, R2
BEQ	R2, R0, L_RTOS_Select_Next_Task301
NOP	
J	L_RTOS_Select_Next_Task24
NOP	
L_RTOS_Select_Next_Task301:
;RTOS.mpas,393 :: 		if LastExecutedTask[Priority] = OS_NO_TASK then LastExecutedTask[Priority] := LastTask; // point to last task
LBU	R3, Offset(RTOS_Priority+0)(GP)
LUI	R2, #hi_addr(RTOS_LastExecutedTask+0)
ORI	R2, R2, #lo_addr(RTOS_LastExecutedTask+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 255
BEQ	R3, R2, L_RTOS_Select_Next_Task302
NOP	
J	L_RTOS_Select_Next_Task26
NOP	
L_RTOS_Select_Next_Task302:
LBU	R3, Offset(RTOS_Priority+0)(GP)
LUI	R2, #hi_addr(RTOS_LastExecutedTask+0)
ORI	R2, R2, #lo_addr(RTOS_LastExecutedTask+0)
ADDU	R3, R2, R3
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SB	R2, 0(R3)
L_RTOS_Select_Next_Task26:
;RTOS.mpas,394 :: 		NextTask_Tmp := LastExecutedTask[Priority];  // round robin per priority
LBU	R3, Offset(RTOS_Priority+0)(GP)
LUI	R2, #hi_addr(RTOS_LastExecutedTask+0)
ORI	R2, R2, #lo_addr(RTOS_LastExecutedTask+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SB	R2, Offset(RTOS_NextTask_Tmp+0)(GP)
;RTOS.mpas,396 :: 		repeat
L_RTOS_Select_Next_Task28:
;RTOS.mpas,397 :: 		inc(NextTask_Tmp);
LBU	R2, Offset(RTOS_NextTask_Tmp+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_NextTask_Tmp+0)(GP)
;RTOS.mpas,398 :: 		if NextTask_Tmp > LastTask then NextTask_Tmp := 0;            // wrap around
ANDI	R3, R2, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R2, R2, R3
BNE	R2, R0, L_RTOS_Select_Next_Task303
NOP	
J	L_RTOS_Select_Next_Task34
NOP	
L_RTOS_Select_Next_Task303:
SB	R0, Offset(RTOS_NextTask_Tmp+0)(GP)
L_RTOS_Select_Next_Task34:
;RTOS.mpas,399 :: 		__State    := TaskData[NextTask_Tmp]._State;
LBU	R3, Offset(RTOS_NextTask_Tmp+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 144
LBU	R4, 0(R2)
SB	R4, Offset(RTOS___State+0)(GP)
;RTOS.mpas,400 :: 		__Priority := TaskData[NextTask_Tmp]._Priority;
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 145
LBU	R3, 0(R2)
SB	R3, Offset(RTOS___Priority+0)(GP)
;RTOS.mpas,401 :: 		until ((__State = st_ELIGIBLE) and (__Priority = Priority)) or  // priority Ok and runnable, or
ANDI	R2, R4, 255
XORI	R4, R2, 4
SLTIU	R4, R4, 1
BEQ	R4, R0, L_RTOS_Select_Next_Task305
NOP	
ADDIU	R4, R0, -1
L_RTOS_Select_Next_Task305:
ANDI	R3, R3, 255
LBU	R2, Offset(RTOS_Priority+0)(GP)
XOR	R2, R3, R2
SLTIU	R2, R2, 1
BEQ	R2, R0, L_RTOS_Select_Next_Task307
NOP	
ADDIU	R2, R0, -1
L_RTOS_Select_Next_Task307:
AND	R4, R4, R2
;RTOS.mpas,402 :: 		(NextTask_Tmp = LastExecutedTask[Priority]);                    // all tasks checked
LBU	R3, Offset(RTOS_Priority+0)(GP)
LUI	R2, #hi_addr(RTOS_LastExecutedTask+0)
ORI	R2, R2, #lo_addr(RTOS_LastExecutedTask+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
ANDI	R3, R2, 255
LBU	R2, Offset(RTOS_NextTask_Tmp+0)(GP)
XOR	R2, R2, R3
SLTIU	R2, R2, 1
BEQ	R2, R0, L_RTOS_Select_Next_Task309
NOP	
ADDIU	R2, R0, -1
L_RTOS_Select_Next_Task309:
OR	R2, R4, R2
BEQ	R2, R0, L_RTOS_Select_Next_Task310
NOP	
J	L_RTOS_Select_Next_Task31
NOP	
L_RTOS_Select_Next_Task310:
J	L_RTOS_Select_Next_Task28
NOP	
L_RTOS_Select_Next_Task31:
;RTOS.mpas,404 :: 		if (__State = st_ELIGIBLE) and (__Priority = Priority) then
LBU	R2, Offset(RTOS___State+0)(GP)
XORI	R4, R2, 4
SLTIU	R4, R4, 1
BEQ	R4, R0, L_RTOS_Select_Next_Task312
NOP	
ADDIU	R4, R0, -1
L_RTOS_Select_Next_Task312:
LBU	R3, Offset(RTOS_Priority+0)(GP)
LBU	R2, Offset(RTOS___Priority+0)(GP)
XOR	R2, R2, R3
SLTIU	R2, R2, 1
BEQ	R2, R0, L_RTOS_Select_Next_Task314
NOP	
ADDIU	R2, R0, -1
L_RTOS_Select_Next_Task314:
AND	R2, R4, R2
BNE	R2, R0, L_RTOS_Select_Next_Task316
NOP	
J	L_RTOS_Select_Next_Task37
NOP	
L_RTOS_Select_Next_Task316:
;RTOS.mpas,406 :: 		NextTask := NextTask_Tmp;
LBU	R2, Offset(RTOS_NextTask_Tmp+0)(GP)
SB	R2, Offset(RTOS_NextTask+0)(GP)
;RTOS.mpas,407 :: 		LastExecutedTask[Priority] := NextTask;
LBU	R3, Offset(RTOS_Priority+0)(GP)
LUI	R2, #hi_addr(RTOS_LastExecutedTask+0)
ORI	R2, R2, #lo_addr(RTOS_LastExecutedTask+0)
ADDU	R3, R2, R3
LBU	R2, Offset(RTOS_NextTask_Tmp+0)(GP)
SB	R2, 0(R3)
;RTOS.mpas,408 :: 		break;
J	L_RTOS_Select_Next_Task24
NOP	
;RTOS.mpas,409 :: 		end;
L_RTOS_Select_Next_Task37:
;RTOS.mpas,410 :: 		end;
LBU	R3, Offset(RTOS_LowestPriority+0)(GP)
LBU	R2, Offset(RTOS_Priority+0)(GP)
BNE	R2, R3, L_RTOS_Select_Next_Task318
NOP	
J	L_RTOS_Select_Next_Task24
NOP	
L_RTOS_Select_Next_Task318:
LBU	R2, Offset(RTOS_Priority+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_Priority+0)(GP)
J	L_RTOS_Select_Next_Task20
NOP	
L_RTOS_Select_Next_Task24:
;RTOS.mpas,411 :: 		end;
L_RTOS_Select_Next_Task18:
;RTOS.mpas,428 :: 		end;
L_end_Select_Next_Task:
JR	RA
NOP	
; end of RTOS_Select_Next_Task
RTOS_Check_Events_ISR:
;RTOS.mpas,440 :: 		begin
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;RTOS.mpas,441 :: 		if LastEvent <> OS_NO_EVENT then
SW	R25, 4(SP)
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
ORI	R2, R0, 255
BNE	R3, R2, L_RTOS_Check_Events_ISR321
NOP	
J	L_RTOS_Check_Events_ISR41
NOP	
L_RTOS_Check_Events_ISR321:
;RTOS.mpas,443 :: 		for Check_Events_I := 0 to LastEvent do
SB	R0, Offset(RTOS_Check_Events_I+0)(GP)
L_RTOS_Check_Events_ISR43:
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
LBU	R2, Offset(RTOS_Check_Events_I+0)(GP)
SLTU	R2, R3, R2
BEQ	R2, R0, L_RTOS_Check_Events_ISR322
NOP	
J	L_RTOS_Check_Events_ISR47
NOP	
L_RTOS_Check_Events_ISR322:
;RTOS.mpas,445 :: 		EventDataPtr := @EventData[Check_Events_I];
LBU	R3, Offset(RTOS_Check_Events_I+0)(GP)
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
SW	R2, Offset(RTOS_EventDataPtr+0)(GP)
;RTOS.mpas,448 :: 		InterruptState := DisableInterrupts;
DI	R30
SW	R30, Offset(RTOS_InterruptState+0)(GP)
;RTOS.mpas,451 :: 		if EventDataPtr^._SemISR > 0 then // there was signaling from an ISR
ADDIU	R2, R2, 4
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 1
BEQ	R2, R0, L_RTOS_Check_Events_ISR323
NOP	
J	L_RTOS_Check_Events_ISR49
NOP	
L_RTOS_Check_Events_ISR323:
;RTOS.mpas,453 :: 		if EventDataPtr^._Type = et_Binary
LW	R2, Offset(RTOS_EventDataPtr+0)(GP)
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 2
BEQ	R3, R2, L_RTOS_Check_Events_ISR324
NOP	
J	L_RTOS_Check_Events_ISR52
NOP	
L_RTOS_Check_Events_ISR324:
;RTOS.mpas,454 :: 		then EventDataPtr^._SemCount := 1                                                // binary semaphore
LW	R2, Offset(RTOS_EventDataPtr+0)(GP)
ADDIU	R3, R2, 2
ORI	R2, R0, 1
SH	R2, 0(R3)
J	L_RTOS_Check_Events_ISR53
NOP	
;RTOS.mpas,455 :: 		else EventDataPtr^._SemCount := EventDataPtr^._SemCount + EventDataPtr^._SemISR; // counting semaphore
L_RTOS_Check_Events_ISR52:
LW	R2, Offset(RTOS_EventDataPtr+0)(GP)
ADDIU	R4, R2, 2
LW	R2, Offset(RTOS_EventDataPtr+0)(GP)
ADDIU	R2, R2, 4
LHU	R3, 0(R2)
LHU	R2, 0(R4)
ADDU	R2, R2, R3
SH	R2, 0(R4)
L_RTOS_Check_Events_ISR53:
;RTOS.mpas,456 :: 		EventDataPtr^._SemISR := 0;
LW	R2, Offset(RTOS_EventDataPtr+0)(GP)
ADDIU	R2, R2, 4
SH	R0, 0(R2)
;RTOS.mpas,457 :: 		end;
L_RTOS_Check_Events_ISR49:
;RTOS.mpas,460 :: 		RestoreInterrupts(InterruptState);
LW	R25, Offset(RTOS_InterruptState+0)(GP)
JAL	_RestoreInterrupts+0
NOP	
;RTOS.mpas,463 :: 		end;
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
LBU	R2, Offset(RTOS_Check_Events_I+0)(GP)
BNE	R2, R3, L_RTOS_Check_Events_ISR326
NOP	
J	L_RTOS_Check_Events_ISR47
NOP	
L_RTOS_Check_Events_ISR326:
LBU	R2, Offset(RTOS_Check_Events_I+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_Check_Events_I+0)(GP)
J	L_RTOS_Check_Events_ISR43
NOP	
L_RTOS_Check_Events_ISR47:
;RTOS.mpas,464 :: 		end;
L_RTOS_Check_Events_ISR41:
;RTOS.mpas,465 :: 		end;
L_end_Check_Events_ISR:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of RTOS_Check_Events_ISR
RTOS_Check_Events:
;RTOS.mpas,469 :: 		begin
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;RTOS.mpas,472 :: 		Check_Events_ISR;
JAL	RTOS_Check_Events_ISR+0
NOP	
;RTOS.mpas,476 :: 		if LastTask <> OS_NO_TASK then
LBU	R3, Offset(RTOS_LastTask+0)(GP)
ORI	R2, R0, 255
BNE	R3, R2, L_RTOS_Check_Events329
NOP	
J	L_RTOS_Check_Events56
NOP	
L_RTOS_Check_Events329:
;RTOS.mpas,478 :: 		for Check_Events_I := 0 to LastTask do
SB	R0, Offset(RTOS_Check_Events_I+0)(GP)
L_RTOS_Check_Events58:
LBU	R3, Offset(RTOS_LastTask+0)(GP)
LBU	R2, Offset(RTOS_Check_Events_I+0)(GP)
SLTU	R2, R3, R2
BEQ	R2, R0, L_RTOS_Check_Events330
NOP	
J	L_RTOS_Check_Events62
NOP	
L_RTOS_Check_Events330:
;RTOS.mpas,480 :: 		TaskDataPtr := @TaskData[Check_Events_I];
LBU	R3, Offset(RTOS_Check_Events_I+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
SW	R2, Offset(RTOS_TaskDataPtr+0)(GP)
;RTOS.mpas,482 :: 		if TaskDataPtr^._State = st_WAITING then  // task is waiting for an event
ADDIU	R2, R2, 144
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 3
BEQ	R3, R2, L_RTOS_Check_Events331
NOP	
J	L_RTOS_Check_Events64
NOP	
L_RTOS_Check_Events331:
;RTOS.mpas,484 :: 		if EventData[TaskDataPtr^._EventID]._SemCount > 0 then
LW	R2, Offset(RTOS_TaskDataPtr+0)(GP)
ADDIU	R2, R2, 148
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 2
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 1
BEQ	R2, R0, L_RTOS_Check_Events332
NOP	
J	L_RTOS_Check_Events67
NOP	
L_RTOS_Check_Events332:
;RTOS.mpas,486 :: 		dec(EventData[TaskDataPtr^._EventID]._SemCount);
LW	R2, Offset(RTOS_TaskDataPtr+0)(GP)
ADDIU	R2, R2, 148
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 2
LHU	R2, 0(R3)
ADDIU	R2, R2, -1
SH	R2, 0(R3)
;RTOS.mpas,487 :: 		TaskDataPtr^._State := st_ELIGIBLE;      // task can be executed
LW	R2, Offset(RTOS_TaskDataPtr+0)(GP)
ADDIU	R3, R2, 144
ORI	R2, R0, 4
SB	R2, 0(R3)
;RTOS.mpas,488 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,489 :: 		end;
L_RTOS_Check_Events67:
;RTOS.mpas,490 :: 		end;
L_RTOS_Check_Events64:
;RTOS.mpas,491 :: 		end;
LBU	R3, Offset(RTOS_LastTask+0)(GP)
LBU	R2, Offset(RTOS_Check_Events_I+0)(GP)
BNE	R2, R3, L_RTOS_Check_Events334
NOP	
J	L_RTOS_Check_Events62
NOP	
L_RTOS_Check_Events334:
LBU	R2, Offset(RTOS_Check_Events_I+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_Check_Events_I+0)(GP)
J	L_RTOS_Check_Events58
NOP	
L_RTOS_Check_Events62:
;RTOS.mpas,492 :: 		end;
L_RTOS_Check_Events56:
;RTOS.mpas,494 :: 		end;
L_end_Check_Events:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of RTOS_Check_Events
RTOS_Check_Timed_Events:
;RTOS.mpas,504 :: 		begin
;RTOS.mpas,505 :: 		if LastTask <> OS_NO_TASK then
LBU	R3, Offset(RTOS_LastTask+0)(GP)
ORI	R2, R0, 255
BNE	R3, R2, L_RTOS_Check_Timed_Events337
NOP	
J	L_RTOS_Check_Timed_Events71
NOP	
L_RTOS_Check_Timed_Events337:
;RTOS.mpas,507 :: 		for OS_Interrupt_I := 0 to LastTask do
SB	R0, Offset(RTOS_OS_Interrupt_I+0)(GP)
L_RTOS_Check_Timed_Events73:
LBU	R3, Offset(RTOS_LastTask+0)(GP)
LBU	R2, Offset(RTOS_OS_Interrupt_I+0)(GP)
SLTU	R2, R3, R2
BEQ	R2, R0, L_RTOS_Check_Timed_Events338
NOP	
J	L_RTOS_Check_Timed_Events77
NOP	
L_RTOS_Check_Timed_Events338:
;RTOS.mpas,509 :: 		OS_Interrupt_Ptr := @TaskData[OS_Interrupt_I];
LBU	R3, Offset(RTOS_OS_Interrupt_I+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
SW	R2, Offset(RTOS_OS_Interrupt_Ptr+0)(GP)
;RTOS.mpas,511 :: 		if (OS_Interrupt_Ptr^._State = st_DELAYED) or (OS_Interrupt_Ptr^._State = st_WAITING) then
ADDIU	R2, R2, 144
LBU	R4, 0(R2)
ANDI	R2, R4, 255
XORI	R3, R2, 2
SLTIU	R3, R3, 1
BEQ	R3, R0, L_RTOS_Check_Timed_Events340
NOP	
ADDIU	R3, R0, -1
L_RTOS_Check_Timed_Events340:
ANDI	R2, R4, 255
XORI	R2, R2, 3
SLTIU	R2, R2, 1
BEQ	R2, R0, L_RTOS_Check_Timed_Events342
NOP	
ADDIU	R2, R0, -1
L_RTOS_Check_Timed_Events342:
OR	R2, R3, R2
BNE	R2, R0, L_RTOS_Check_Timed_Events344
NOP	
J	L_RTOS_Check_Timed_Events79
NOP	
L_RTOS_Check_Timed_Events344:
;RTOS.mpas,513 :: 		if OS_Interrupt_Ptr^._Timer > 0 then
LW	R2, Offset(RTOS_OS_Interrupt_Ptr+0)(GP)
ADDIU	R2, R2, 146
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 1
BEQ	R2, R0, L_RTOS_Check_Timed_Events345
NOP	
J	L_RTOS_Check_Timed_Events82
NOP	
L_RTOS_Check_Timed_Events345:
;RTOS.mpas,515 :: 		dec(OS_Interrupt_Ptr^._Timer);
LW	R2, Offset(RTOS_OS_Interrupt_Ptr+0)(GP)
ADDIU	R3, R2, 146
LHU	R2, 0(R3)
ADDIU	R2, R2, -1
SH	R2, 0(R3)
;RTOS.mpas,517 :: 		if OS_Interrupt_Ptr^._Timer = 0 then
LW	R2, Offset(RTOS_OS_Interrupt_Ptr+0)(GP)
ADDIU	R2, R2, 146
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
BEQ	R2, R0, L_RTOS_Check_Timed_Events346
NOP	
J	L_RTOS_Check_Timed_Events85
NOP	
L_RTOS_Check_Timed_Events346:
;RTOS.mpas,519 :: 		case OS_Interrupt_Ptr^._State of
LW	R2, Offset(RTOS_OS_Interrupt_Ptr+0)(GP)
ADDIU	R2, R2, 144
LBU	R4, 0(R2)
;RTOS.mpas,521 :: 		st_DELAYED: //
ANDI	R3, R4, 255
ORI	R2, R0, 2
BEQ	R3, R2, L_RTOS_Check_Timed_Events347
NOP	
J	L_RTOS_Check_Timed_Events90
NOP	
L_RTOS_Check_Timed_Events347:
;RTOS.mpas,523 :: 		OS_Interrupt_Ptr^._State := st_ELIGIBLE;  // timer was a delay timer
LW	R2, Offset(RTOS_OS_Interrupt_Ptr+0)(GP)
ADDIU	R3, R2, 144
ORI	R2, R0, 4
SB	R2, 0(R3)
;RTOS.mpas,524 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,525 :: 		end;
J	L_RTOS_Check_Timed_Events87
NOP	
L_RTOS_Check_Timed_Events90:
;RTOS.mpas,529 :: 		st_WAITING: //
ANDI	R3, R4, 255
ORI	R2, R0, 3
BEQ	R3, R2, L_RTOS_Check_Timed_Events348
NOP	
J	L_RTOS_Check_Timed_Events93
NOP	
L_RTOS_Check_Timed_Events348:
;RTOS.mpas,531 :: 		OS_Interrupt_Ptr^._Misc.mi_TIMEOUT_bit := 1; // timer was a timeout timer
LW	R2, Offset(RTOS_OS_Interrupt_Ptr+0)(GP)
ADDIU	R3, R2, 149
LBU	R2, 0(R3)
ORI	R2, R2, 1
SB	R2, 0(R3)
;RTOS.mpas,532 :: 		OS_Interrupt_Ptr^._State := st_ELIGIBLE;
LW	R2, Offset(RTOS_OS_Interrupt_Ptr+0)(GP)
ADDIU	R3, R2, 144
ORI	R2, R0, 4
SB	R2, 0(R3)
;RTOS.mpas,533 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,534 :: 		end;
J	L_RTOS_Check_Timed_Events87
NOP	
L_RTOS_Check_Timed_Events93:
L_RTOS_Check_Timed_Events87:
;RTOS.mpas,537 :: 		end;
L_RTOS_Check_Timed_Events85:
;RTOS.mpas,539 :: 		end;
L_RTOS_Check_Timed_Events82:
;RTOS.mpas,540 :: 		end;
L_RTOS_Check_Timed_Events79:
;RTOS.mpas,542 :: 		end;
LBU	R3, Offset(RTOS_LastTask+0)(GP)
LBU	R2, Offset(RTOS_OS_Interrupt_I+0)(GP)
BNE	R2, R3, L_RTOS_Check_Timed_Events350
NOP	
J	L_RTOS_Check_Timed_Events77
NOP	
L_RTOS_Check_Timed_Events350:
LBU	R2, Offset(RTOS_OS_Interrupt_I+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_OS_Interrupt_I+0)(GP)
J	L_RTOS_Check_Timed_Events73
NOP	
L_RTOS_Check_Timed_Events77:
;RTOS.mpas,543 :: 		end;
L_RTOS_Check_Timed_Events71:
;RTOS.mpas,544 :: 		end;
L_end_Check_Timed_Events:
JR	RA
NOP	
; end of RTOS_Check_Timed_Events
RTOS_CheckStack:
;RTOS.mpas,552 :: 		begin
;RTOS.mpas,553 :: 		if CurrentTask <> OS_NO_TASK then
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 255
BNE	R3, R2, L_RTOS_CheckStack353
NOP	
J	L_RTOS_CheckStack96
NOP	
L_RTOS_CheckStack353:
;RTOS.mpas,555 :: 		CheckStack_I := 0;
SH	R0, Offset(RTOS_CheckStack_I+0)(GP)
;RTOS.mpas,556 :: 		CheckStackPtr := ^byte(TaskData[CurrentTask]._StackBase);
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 152
LW	R2, 0(R2)
SW	R2, Offset(RTOS_CheckStackPtr+0)(GP)
;RTOS.mpas,557 :: 		while (CheckStackPtr^ = 0) and (CheckStack_I < OS_Task_StackSize) do
L_RTOS_CheckStack99:
LW	R2, Offset(RTOS_CheckStackPtr+0)(GP)
LBU	R2, 0(R2)
ANDI	R2, R2, 255
XORI	R3, R2, 0
SLTIU	R3, R3, 1
BEQ	R3, R0, L_RTOS_CheckStack355
NOP	
ADDIU	R3, R0, -1
L_RTOS_CheckStack355:
LHU	R2, Offset(RTOS_CheckStack_I+0)(GP)
SLTIU	R2, R2, 100
BEQ	R2, R0, L_RTOS_CheckStack357
NOP	
ADDIU	R2, R0, -1
L_RTOS_CheckStack357:
AND	R2, R3, R2
BNE	R2, R0, L_RTOS_CheckStack359
NOP	
J	L_RTOS_CheckStack100
NOP	
L_RTOS_CheckStack359:
;RTOS.mpas,559 :: 		inc(CheckStackPtr);
LW	R2, Offset(RTOS_CheckStackPtr+0)(GP)
ADDIU	R2, R2, 1
SW	R2, Offset(RTOS_CheckStackPtr+0)(GP)
;RTOS.mpas,560 :: 		inc(CheckStack_I);
LHU	R2, Offset(RTOS_CheckStack_I+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(RTOS_CheckStack_I+0)(GP)
;RTOS.mpas,561 :: 		end;
J	L_RTOS_CheckStack99
NOP	
L_RTOS_CheckStack100:
;RTOS.mpas,562 :: 		TaskData[CurrentTask]._StackUsage := (Dword(OS_Task_StackSize - CheckStack_I) * 100) div OS_Task_StackSize;
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R4, R2, 156
LHU	R3, Offset(RTOS_CheckStack_I+0)(GP)
ORI	R2, R0, 100
SUBU	R3, R2, R3
ORI	R2, R0, 100
MULTU	R3, R2
MFLO	R3
ORI	R2, R0, 100
DIVU	R3, R2
MFLO	R2
SB	R2, 0(R4)
;RTOS.mpas,563 :: 		end;
L_RTOS_CheckStack96:
;RTOS.mpas,564 :: 		end;
L_end_CheckStack:
JR	RA
NOP	
; end of RTOS_CheckStack
RTOS_Timer1Int:
;RTOS.mpas,574 :: 		begin
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;RTOS.mpas,578 :: 		TmpRegs[1] := R1;
SW	GP, Offset(RTOS_TmpRegs+4)(GP)
;RTOS.mpas,579 :: 		TmpRegs[2] := R2;
SW	R2, Offset(RTOS_TmpRegs+8)(GP)
;RTOS.mpas,580 :: 		TmpRegs[3] := R3;
SW	R3, Offset(RTOS_TmpRegs+12)(GP)
;RTOS.mpas,581 :: 		TmpRegs[4] := R4;
SW	R4, Offset(RTOS_TmpRegs+16)(GP)
;RTOS.mpas,582 :: 		TmpRegs[5] := R5;
SW	R5, Offset(RTOS_TmpRegs+20)(GP)
;RTOS.mpas,583 :: 		TmpRegs[6] := R6;
SW	R6, Offset(RTOS_TmpRegs+24)(GP)
;RTOS.mpas,584 :: 		TmpRegs[7] := R7;
SW	R7, Offset(RTOS_TmpRegs+28)(GP)
;RTOS.mpas,585 :: 		TmpRegs[8] := R8;
SW	R8, Offset(RTOS_TmpRegs+32)(GP)
;RTOS.mpas,586 :: 		TmpRegs[9] := R9;
SW	R9, Offset(RTOS_TmpRegs+36)(GP)
;RTOS.mpas,587 :: 		TmpRegs[10] := R10;
SW	R10, Offset(RTOS_TmpRegs+40)(GP)
;RTOS.mpas,588 :: 		TmpRegs[11] := R11;
SW	R11, Offset(RTOS_TmpRegs+44)(GP)
;RTOS.mpas,589 :: 		TmpRegs[12] := R12;
SW	R12, Offset(RTOS_TmpRegs+48)(GP)
;RTOS.mpas,590 :: 		TmpRegs[13] := R13;
SW	R13, Offset(RTOS_TmpRegs+52)(GP)
;RTOS.mpas,591 :: 		TmpRegs[14] := R14;
SW	R14, Offset(RTOS_TmpRegs+56)(GP)
;RTOS.mpas,592 :: 		TmpRegs[15] := R15;
SW	R15, Offset(RTOS_TmpRegs+60)(GP)
;RTOS.mpas,593 :: 		TmpRegs[16] := R16;
SW	R16, Offset(RTOS_TmpRegs+64)(GP)
;RTOS.mpas,594 :: 		TmpRegs[17] := R17;
SW	R17, Offset(RTOS_TmpRegs+68)(GP)
;RTOS.mpas,595 :: 		TmpRegs[18] := R18;
SW	R18, Offset(RTOS_TmpRegs+72)(GP)
;RTOS.mpas,596 :: 		TmpRegs[19] := R19;
SW	R19, Offset(RTOS_TmpRegs+76)(GP)
;RTOS.mpas,597 :: 		TmpRegs[20] := R20;
SW	R20, Offset(RTOS_TmpRegs+80)(GP)
;RTOS.mpas,598 :: 		TmpRegs[21] := R21;
SW	R21, Offset(RTOS_TmpRegs+84)(GP)
;RTOS.mpas,599 :: 		TmpRegs[22] := R22;
SW	R22, Offset(RTOS_TmpRegs+88)(GP)
;RTOS.mpas,600 :: 		TmpRegs[23] := R23;
SW	R23, Offset(RTOS_TmpRegs+92)(GP)
;RTOS.mpas,601 :: 		TmpRegs[24] := R24;
SW	R24, Offset(RTOS_TmpRegs+96)(GP)
;RTOS.mpas,602 :: 		TmpRegs[25] := R25;
SW	R25, Offset(RTOS_TmpRegs+100)(GP)
;RTOS.mpas,603 :: 		TmpRegs[26] := R26;
SW	R26, Offset(RTOS_TmpRegs+104)(GP)
;RTOS.mpas,604 :: 		TmpRegs[27] := R27;
SW	R27, Offset(RTOS_TmpRegs+108)(GP)
;RTOS.mpas,605 :: 		TmpRegs[28] := R28;
SW	R28, Offset(RTOS_TmpRegs+112)(GP)
;RTOS.mpas,606 :: 		TmpRegs[29] := R29;
SW	SP, Offset(RTOS_TmpRegs+116)(GP)
;RTOS.mpas,607 :: 		TmpRegs[30] := R30;
SW	R30, Offset(RTOS_TmpRegs+120)(GP)
;RTOS.mpas,608 :: 		TmpRegs[31] := R31;
SW	RA, Offset(RTOS_TmpRegs+124)(GP)
;RTOS.mpas,612 :: 		MFC0        R30, 12, 0
MFC0	R30, 12, 0
;RTOS.mpas,614 :: 		TmpStat := R30; // and save it
SW	R30, Offset(RTOS_TmpStat+0)(GP)
;RTOS.mpas,618 :: 		MFHI R30
MFHI	R30
;RTOS.mpas,620 :: 		TmpHi := R30;
SW	R30, Offset(RTOS_TmpHI+0)(GP)
;RTOS.mpas,623 :: 		MFLO R30
MFLO	R30
;RTOS.mpas,625 :: 		TmpLo := R30;
SW	R30, Offset(RTOS_TmpLO+0)(GP)
;RTOS.mpas,629 :: 		MFC0        R30, 14, 0
MFC0	R30, 14, 0
;RTOS.mpas,631 :: 		TmpAddr := R30;
SW	R30, Offset(RTOS_TmpAddr+0)(GP)
;RTOS.mpas,633 :: 		T1IF_bit    := 0; // Clear timer interrupt bit
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+4), 4
;RTOS.mpas,635 :: 		if not Immediate then
LW	R2, Offset(RTOS_Immediate+0)(GP)
NOR	R2, R2, R0
BNE	R2, R0, L_RTOS_Timer1Int362
NOP	
J	L_RTOS_Timer1Int105
NOP	
L_RTOS_Timer1Int362:
;RTOS.mpas,637 :: 		inc(OS_Count); // increment the interrupt counter if no forced interrupt
LBU	R2, Offset(RTOS_OS_Count+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_OS_Count+0)(GP)
;RTOS.mpas,641 :: 		Check_Timed_Events; // only decrement the timers if no forced interrupt
JAL	RTOS_Check_Timed_Events+0
NOP	
;RTOS.mpas,643 :: 		end;
L_RTOS_Timer1Int105:
;RTOS.mpas,646 :: 		Check_Events; // check if there are any pending events (signalled semaphores)
JAL	RTOS_Check_Events+0
NOP	
;RTOS.mpas,649 :: 		if Immediate or (OS_Count >= IntTime) then // time to switch tasks
LBU	R2, Offset(RTOS_OS_Count+0)(GP)
SLTIU	R3, R2, 10
XORI	R3, R3, 1
BEQ	R3, R0, L_RTOS_Timer1Int364
NOP	
ADDIU	R3, R0, -1
L_RTOS_Timer1Int364:
LW	R2, Offset(RTOS_Immediate+0)(GP)
OR	R2, R2, R3
BNE	R2, R0, L_RTOS_Timer1Int366
NOP	
J	L_RTOS_Timer1Int108
NOP	
L_RTOS_Timer1Int366:
;RTOS.mpas,651 :: 		OS_Count  := 0;
SB	R0, Offset(RTOS_OS_Count+0)(GP)
;RTOS.mpas,652 :: 		Immediate := false;
SW	R0, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,656 :: 		MFC0        R30, 12, 0; get processor status
MFC0	R30, 12, 0
;RTOS.mpas,657 :: 		INS         R30, R0, 1, 15; clear bits 1..15
INS	R30, R0, 1, 15
;RTOS.mpas,658 :: 		ORI         R30, R0, $1800; set bits for iLevel6
ORI	R30, R0, 6144
;RTOS.mpas,659 :: 		MTC0        R30, 12, 0; set processor status
MTC0	R30, 12, 0
;RTOS.mpas,663 :: 		Timer1Int_Ptr := nil;
SW	R0, Offset(RTOS_Timer1Int_Ptr+0)(GP)
;RTOS.mpas,664 :: 		if CurrentTask <> OS_NO_TASK
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 255
BNE	R3, R2, L_RTOS_Timer1Int368
NOP	
J	L_RTOS_Timer1Int111
NOP	
L_RTOS_Timer1Int368:
;RTOS.mpas,665 :: 		then Timer1Int_Ptr := @TaskData[CurrentTask]
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
SW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
J	L_RTOS_Timer1Int112
NOP	
;RTOS.mpas,666 :: 		else if IdleRunning then Timer1Int_Ptr := @IdleData;
L_RTOS_Timer1Int111:
LW	R2, Offset(RTOS_IdleRunning+0)(GP)
BNE	R2, R0, L_RTOS_Timer1Int370
NOP	
J	L_RTOS_Timer1Int114
NOP	
L_RTOS_Timer1Int370:
LUI	R2, #hi_addr(RTOS_IdleData+0)
ORI	R2, R2, #lo_addr(RTOS_IdleData+0)
SW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
L_RTOS_Timer1Int114:
L_RTOS_Timer1Int112:
;RTOS.mpas,668 :: 		if (Timer1Int_Ptr <> nil) then
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
BNE	R2, R0, L_RTOS_Timer1Int372
NOP	
J	L_RTOS_Timer1Int117
NOP	
L_RTOS_Timer1Int372:
;RTOS.mpas,670 :: 		for OS_I := 0 to 31 do Timer1Int_Ptr^.Regs[OS_I] := TmpRegs[OS_I];
SB	R0, Offset(RTOS_OS_I+0)(GP)
L_RTOS_Timer1Int120:
LBU	R2, Offset(RTOS_OS_I+0)(GP)
SLL	R4, R2, 2
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDU	R3, R2, R4
LUI	R2, #hi_addr(RTOS_TmpRegs+0)
ORI	R2, R2, #lo_addr(RTOS_TmpRegs+0)
ADDU	R2, R2, R4
LW	R2, 0(R2)
SW	R2, 0(R3)
LBU	R3, Offset(RTOS_OS_I+0)(GP)
ORI	R2, R0, 31
BNE	R3, R2, L_RTOS_Timer1Int374
NOP	
J	L_RTOS_Timer1Int123
NOP	
L_RTOS_Timer1Int374:
LBU	R2, Offset(RTOS_OS_I+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_OS_I+0)(GP)
J	L_RTOS_Timer1Int120
NOP	
L_RTOS_Timer1Int123:
;RTOS.mpas,671 :: 		Timer1Int_Ptr^.HiVal   := TmpHi;
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDIU	R3, R2, 132
LW	R2, Offset(RTOS_TmpHI+0)(GP)
SW	R2, 0(R3)
;RTOS.mpas,672 :: 		Timer1Int_Ptr^.LoVal   := TmpLo;
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDIU	R3, R2, 136
LW	R2, Offset(RTOS_TmpLO+0)(GP)
SW	R2, 0(R3)
;RTOS.mpas,673 :: 		Timer1Int_Ptr^.Status_ := TmpStat;
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDIU	R3, R2, 140
LW	R2, Offset(RTOS_TmpStat+0)(GP)
SW	R2, 0(R3)
;RTOS.mpas,674 :: 		Timer1Int_Ptr^.RetAddr := TmpAddr;
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDIU	R3, R2, 128
LW	R2, Offset(RTOS_TmpAddr+0)(GP)
SW	R2, 0(R3)
;RTOS.mpas,675 :: 		end;
L_RTOS_Timer1Int117:
;RTOS.mpas,678 :: 		CheckStack;
JAL	RTOS_CheckStack+0
NOP	
;RTOS.mpas,682 :: 		Select_Next_Task;
JAL	RTOS_Select_Next_Task+0
NOP	
;RTOS.mpas,684 :: 		if NextTask <> OS_NO_TASK then // task to execute found
LBU	R3, Offset(RTOS_NextTask+0)(GP)
ORI	R2, R0, 255
BNE	R3, R2, L_RTOS_Timer1Int376
NOP	
J	L_RTOS_Timer1Int125
NOP	
L_RTOS_Timer1Int376:
;RTOS.mpas,686 :: 		CurrentTask   := NextTask;
LBU	R2, Offset(RTOS_NextTask+0)(GP)
SB	R2, Offset(RTOS_CurrentTask+0)(GP)
;RTOS.mpas,687 :: 		Timer1Int_Ptr := @TaskData[CurrentTask];
LBU	R3, Offset(RTOS_NextTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
SW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
;RTOS.mpas,688 :: 		IdleRunning   := false;
SW	R0, Offset(RTOS_IdleRunning+0)(GP)
;RTOS.mpas,689 :: 		end
J	L_RTOS_Timer1Int126
NOP	
;RTOS.mpas,690 :: 		else  // no task to execute found, execute the idle task
L_RTOS_Timer1Int125:
;RTOS.mpas,692 :: 		CurrentTask   := OS_NO_TASK;
ORI	R2, R0, 255
SB	R2, Offset(RTOS_CurrentTask+0)(GP)
;RTOS.mpas,693 :: 		Timer1Int_Ptr := @IdleData;
LUI	R2, #hi_addr(RTOS_IdleData+0)
ORI	R2, R2, #lo_addr(RTOS_IdleData+0)
SW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
;RTOS.mpas,694 :: 		IdleRunning   := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_IdleRunning+0)(GP)
;RTOS.mpas,695 :: 		end;
L_RTOS_Timer1Int126:
;RTOS.mpas,698 :: 		for OS_I := 0 to 31 do TmpRegs[OS_I] := Timer1Int_Ptr^.Regs[OS_I];
SB	R0, Offset(RTOS_OS_I+0)(GP)
L_RTOS_Timer1Int128:
LBU	R2, Offset(RTOS_OS_I+0)(GP)
SLL	R4, R2, 2
LUI	R2, #hi_addr(RTOS_TmpRegs+0)
ORI	R2, R2, #lo_addr(RTOS_TmpRegs+0)
ADDU	R3, R2, R4
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDU	R2, R2, R4
LW	R2, 0(R2)
SW	R2, 0(R3)
LBU	R3, Offset(RTOS_OS_I+0)(GP)
ORI	R2, R0, 31
BNE	R3, R2, L_RTOS_Timer1Int378
NOP	
J	L_RTOS_Timer1Int131
NOP	
L_RTOS_Timer1Int378:
LBU	R2, Offset(RTOS_OS_I+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_OS_I+0)(GP)
J	L_RTOS_Timer1Int128
NOP	
L_RTOS_Timer1Int131:
;RTOS.mpas,699 :: 		TmpHi   := Timer1Int_Ptr^.HiVal;
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDIU	R2, R2, 132
LW	R2, 0(R2)
SW	R2, Offset(RTOS_TmpHI+0)(GP)
;RTOS.mpas,700 :: 		TmpLo   := Timer1Int_Ptr^.LoVal;
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDIU	R2, R2, 136
LW	R2, 0(R2)
SW	R2, Offset(RTOS_TmpLO+0)(GP)
;RTOS.mpas,701 :: 		TmpStat := Timer1Int_Ptr^.Status_;
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDIU	R2, R2, 140
LW	R2, 0(R2)
SW	R2, Offset(RTOS_TmpStat+0)(GP)
;RTOS.mpas,702 :: 		TmpAddr := Timer1Int_Ptr^.RetAddr;
LW	R2, Offset(RTOS_Timer1Int_Ptr+0)(GP)
ADDIU	R2, R2, 128
LW	R2, 0(R2)
SW	R2, Offset(RTOS_TmpAddr+0)(GP)
;RTOS.mpas,703 :: 		end;
L_RTOS_Timer1Int108:
;RTOS.mpas,706 :: 		R30 := TmpAddr;
LW	R30, Offset(RTOS_TmpAddr+0)(GP)
;RTOS.mpas,708 :: 		MTC0        R30, 14, 0
MTC0	R30, 14, 0
;RTOS.mpas,712 :: 		R30 := TmpStat;
LW	R30, Offset(RTOS_TmpStat+0)(GP)
;RTOS.mpas,714 :: 		MTC0        R30, 12, 0
MTC0	R30, 12, 0
;RTOS.mpas,718 :: 		R30 := TmpHi;
LW	R30, Offset(RTOS_TmpHI+0)(GP)
;RTOS.mpas,720 :: 		MTHI R30
MTHI	R30
;RTOS.mpas,723 :: 		R30 := TmpLo;
LW	R30, Offset(RTOS_TmpLO+0)(GP)
;RTOS.mpas,725 :: 		MTLO R30
MTLO	R30
;RTOS.mpas,729 :: 		R1 := TmpRegs[1];
LW	GP, Offset(RTOS_TmpRegs+4)(GP)
;RTOS.mpas,730 :: 		R2 := TmpRegs[2];
LW	R2, Offset(RTOS_TmpRegs+8)(GP)
;RTOS.mpas,731 :: 		R3 := TmpRegs[3];
LW	R3, Offset(RTOS_TmpRegs+12)(GP)
;RTOS.mpas,732 :: 		R4 := TmpRegs[4];
LW	R4, Offset(RTOS_TmpRegs+16)(GP)
;RTOS.mpas,733 :: 		R5 := TmpRegs[5];
LW	R5, Offset(RTOS_TmpRegs+20)(GP)
;RTOS.mpas,734 :: 		R6 := TmpRegs[6];
LW	R6, Offset(RTOS_TmpRegs+24)(GP)
;RTOS.mpas,735 :: 		R7 := TmpRegs[7];
LW	R7, Offset(RTOS_TmpRegs+28)(GP)
;RTOS.mpas,736 :: 		R8 := TmpRegs[8];
LW	R8, Offset(RTOS_TmpRegs+32)(GP)
;RTOS.mpas,737 :: 		R9 := TmpRegs[9];
LW	R9, Offset(RTOS_TmpRegs+36)(GP)
;RTOS.mpas,738 :: 		R10 := TmpRegs[10];
LW	R10, Offset(RTOS_TmpRegs+40)(GP)
;RTOS.mpas,739 :: 		R11 := TmpRegs[11];
LW	R11, Offset(RTOS_TmpRegs+44)(GP)
;RTOS.mpas,740 :: 		R12 := TmpRegs[12];
LW	R12, Offset(RTOS_TmpRegs+48)(GP)
;RTOS.mpas,741 :: 		R13 := TmpRegs[13];
LW	R13, Offset(RTOS_TmpRegs+52)(GP)
;RTOS.mpas,742 :: 		R14 := TmpRegs[14];
LW	R14, Offset(RTOS_TmpRegs+56)(GP)
;RTOS.mpas,743 :: 		R15 := TmpRegs[15];
LW	R15, Offset(RTOS_TmpRegs+60)(GP)
;RTOS.mpas,744 :: 		R16 := TmpRegs[16];
LW	R16, Offset(RTOS_TmpRegs+64)(GP)
;RTOS.mpas,745 :: 		R17 := TmpRegs[17];
LW	R17, Offset(RTOS_TmpRegs+68)(GP)
;RTOS.mpas,746 :: 		R18 := TmpRegs[18];
LW	R18, Offset(RTOS_TmpRegs+72)(GP)
;RTOS.mpas,747 :: 		R19 := TmpRegs[19];
LW	R19, Offset(RTOS_TmpRegs+76)(GP)
;RTOS.mpas,748 :: 		R20 := TmpRegs[20];
LW	R20, Offset(RTOS_TmpRegs+80)(GP)
;RTOS.mpas,749 :: 		R21 := TmpRegs[21];
LW	R21, Offset(RTOS_TmpRegs+84)(GP)
;RTOS.mpas,750 :: 		R22 := TmpRegs[22];
LW	R22, Offset(RTOS_TmpRegs+88)(GP)
;RTOS.mpas,751 :: 		R23 := TmpRegs[23];
LW	R23, Offset(RTOS_TmpRegs+92)(GP)
;RTOS.mpas,752 :: 		R24 := TmpRegs[24];
LW	R24, Offset(RTOS_TmpRegs+96)(GP)
;RTOS.mpas,753 :: 		R25 := TmpRegs[25];
LW	R25, Offset(RTOS_TmpRegs+100)(GP)
;RTOS.mpas,754 :: 		R26 := TmpRegs[26];
LW	R26, Offset(RTOS_TmpRegs+104)(GP)
;RTOS.mpas,755 :: 		R27 := TmpRegs[27];
LW	R27, Offset(RTOS_TmpRegs+108)(GP)
;RTOS.mpas,756 :: 		R28 := TmpRegs[28];
LW	R28, Offset(RTOS_TmpRegs+112)(GP)
;RTOS.mpas,757 :: 		R29 := TmpRegs[29];
LW	SP, Offset(RTOS_TmpRegs+116)(GP)
;RTOS.mpas,758 :: 		R30 := TmpRegs[30];
LW	R30, Offset(RTOS_TmpRegs+120)(GP)
;RTOS.mpas,759 :: 		R31 := TmpRegs[31];
LW	RA, Offset(RTOS_TmpRegs+124)(GP)
;RTOS.mpas,761 :: 		end;
L_end_Timer1Int:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
ERET	
; end of RTOS_Timer1Int
_OS_CreateTask:
;RTOS.mpas,771 :: 		begin
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;RTOS.mpas,772 :: 		Result := OS_NO_TASK;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
; Result start address is: 28 (R7)
ORI	R7, R0, 255
;RTOS.mpas,774 :: 		if LastTask = (OS_TASKS_COUNT - 1) then exit; // no free tasks in the list any more
LBU	R3, Offset(RTOS_LastTask+0)(GP)
ORI	R2, R0, 9
BEQ	R3, R2, L__OS_CreateTask380
NOP	
J	L__OS_CreateTask134
NOP	
L__OS_CreateTask380:
ANDI	R3, R7, 255
J	L_end__OS_CreateTask
NOP	
L__OS_CreateTask134:
;RTOS.mpas,776 :: 		GetMemAlign(Create_Task_MemPtr, OS_Task_StackSize + 4, 4); // get memory for stack
SB	R26, 16(SP)
SW	R25, 20(SP)
ORI	R27, R0, 4
ORI	R26, R0, 104
LUI	R25, #hi_addr(RTOS_Create_Task_MemPtr+0)
ORI	R25, R25, #lo_addr(RTOS_Create_Task_MemPtr+0)
JAL	_GetMemAlign+0
NOP	
LW	R25, 20(SP)
LBU	R26, 16(SP)
;RTOS.mpas,777 :: 		if Create_Task_MemPtr = nil then exit;
LW	R2, Offset(RTOS_Create_Task_MemPtr+0)(GP)
BEQ	R2, R0, L__OS_CreateTask381
NOP	
J	L__OS_CreateTask137
NOP	
L__OS_CreateTask381:
ANDI	R3, R7, 255
; Result end address is: 28 (R7)
J	L_end__OS_CreateTask
NOP	
L__OS_CreateTask137:
;RTOS.mpas,779 :: 		if LastTask = OS_NO_TASK
LBU	R3, Offset(RTOS_LastTask+0)(GP)
ORI	R2, R0, 255
BEQ	R3, R2, L__OS_CreateTask382
NOP	
J	L__OS_CreateTask140
NOP	
L__OS_CreateTask382:
;RTOS.mpas,780 :: 		then LastTask := 0
SB	R0, Offset(RTOS_LastTask+0)(GP)
J	L__OS_CreateTask141
NOP	
;RTOS.mpas,781 :: 		else inc(LastTask);
L__OS_CreateTask140:
LBU	R2, Offset(RTOS_LastTask+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_LastTask+0)(GP)
L__OS_CreateTask141:
;RTOS.mpas,783 :: 		Result := LastTask;
; Result start address is: 16 (R4)
LBU	R4, Offset(RTOS_LastTask+0)(GP)
;RTOS.mpas,785 :: 		OS_CreateTask_TmpD := Dword(TaskProc);
SW	R25, Offset(RTOS_OS_CreateTask_TmpD+0)(GP)
;RTOS.mpas,787 :: 		with TaskData[LastTask] do
LBU	R3, Offset(RTOS_LastTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
; indwith??T435 start address is: 20 (R5)
MOVZ	R5, R2, R0
;RTOS.mpas,789 :: 		_State := st_STOPPED;
ADDIU	R3, R2, 144
ORI	R2, R0, 1
SB	R2, 0(R3)
;RTOS.mpas,791 :: 		if Priority >= OS_PRIORITY_COUNT then Priority   := OS_PRIORITY_COUNT - 1;
ANDI	R2, R26, 255
SLTIU	R2, R2, 10
BEQ	R2, R0, L__OS_CreateTask383
NOP	
J	L__OS_CreateTask143
NOP	
L__OS_CreateTask383:
ORI	R26, R0, 9
L__OS_CreateTask143:
;RTOS.mpas,792 :: 		if Priority > LowestPriority then LowestPriority := Priority;
ANDI	R3, R26, 255
LBU	R2, Offset(RTOS_LowestPriority+0)(GP)
SLTU	R2, R2, R3
BNE	R2, R0, L__OS_CreateTask384
NOP	
J	L__OS_CreateTask146
NOP	
L__OS_CreateTask384:
SB	R26, Offset(RTOS_LowestPriority+0)(GP)
L__OS_CreateTask146:
;RTOS.mpas,793 :: 		_Priority := Priority;
ADDIU	R2, R5, 145
SB	R26, 0(R2)
;RTOS.mpas,796 :: 		_Misc := 0;                  // set all bits to zero
ADDIU	R2, R5, 149
SB	R0, 0(R2)
;RTOS.mpas,799 :: 		_StackBase  := dword(Create_Task_MemPtr);
ADDIU	R3, R5, 152
LW	R2, Offset(RTOS_Create_Task_MemPtr+0)(GP)
SW	R2, 0(R3)
;RTOS.mpas,800 :: 		_StackUsage := 0;
ADDIU	R2, R5, 156
SB	R0, 0(R2)
;RTOS.mpas,801 :: 		memset(Create_Task_MemPtr, 0, OS_Task_StackSize + 4);
ORI	R27, R0, 104
MOVZ	R26, R0, R0
LW	R25, Offset(RTOS_Create_Task_MemPtr+0)(GP)
JAL	_memset+0
NOP	
;RTOS.mpas,804 :: 		Regs[1] := GP; // global pointer to global variables
ADDIU	R2, R5, 4
SW	GP, 0(R2)
;RTOS.mpas,806 :: 		Regs[29] := dword(Create_Task_MemPtr) + OS_Task_StackSize; // Initial stackpointer = Top of stack. (OS_Task_StackSize bytes stack for each task)
ADDIU	R3, R5, 116
LW	R2, Offset(RTOS_Create_Task_MemPtr+0)(GP)
ADDIU	R2, R2, 100
SW	R2, 0(R3)
;RTOS.mpas,808 :: 		RetAddr := OS_CreateTask_TmpD;  // store return address
ADDIU	R3, R5, 128
LW	R2, Offset(RTOS_OS_CreateTask_TmpD+0)(GP)
SW	R2, 0(R3)
;RTOS.mpas,811 :: 		MFHI R30
MFHI	R30
;RTOS.mpas,813 :: 		HiVal := R30;
ADDIU	R2, R5, 132
SW	R30, 0(R2)
;RTOS.mpas,816 :: 		MFLO R30
MFLO	R30
;RTOS.mpas,818 :: 		LoVal := R30;
ADDIU	R2, R5, 136
SW	R30, 0(R2)
;RTOS.mpas,821 :: 		MFC0        R30, 12, 0
MFC0	R30, 12, 0
;RTOS.mpas,823 :: 		Status_ := R30 or 1; // set interrupt enable
ADDIU	R3, R5, 140
; indwith??T435 end address is: 20 (R5)
ORI	R2, R30, 1
SW	R2, 0(R3)
; Result end address is: 16 (R4)
ANDI	R3, R4, 255
;RTOS.mpas,826 :: 		end;
L_end__OS_CreateTask:
; Result start address is: 12 (R3)
ANDI	R2, R3, 255
; Result end address is: 12 (R3)
L_end_OS_CreateTask:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _OS_CreateTask
_OS_StartTask:
;RTOS.mpas,829 :: 		begin
;RTOS.mpas,830 :: 		if (TaskID > LastTask) then exit; // not a valid TaskID
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R2, R2, R3
BNE	R2, R0, L__OS_StartTask386
NOP	
J	L__OS_StartTask150
NOP	
L__OS_StartTask386:
J	L_end__OS_StartTask
NOP	
L__OS_StartTask150:
;RTOS.mpas,833 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,835 :: 		if (TaskData[TaskID]._State = st_STOPPED) then
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 144
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__OS_StartTask387
NOP	
J	L__OS_StartTask153
NOP	
L__OS_StartTask387:
;RTOS.mpas,837 :: 		Taskdata[TaskID]._State := st_ELIGIBLE;
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 144
ORI	R2, R0, 4
SB	R2, 0(R3)
;RTOS.mpas,838 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,839 :: 		T1IF_bit := 1;
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+8), 4
;RTOS.mpas,840 :: 		end;
L__OS_StartTask153:
;RTOS.mpas,843 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,844 :: 		end;
L_end__OS_StartTask:
L_end_OS_StartTask:
JR	RA
NOP	
; end of _OS_StartTask
_OS_StartTask_Delay:
;RTOS.mpas,848 :: 		begin
;RTOS.mpas,849 :: 		if (TaskID > LastTask) then exit; // not a valid TaskID
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R2, R2, R3
BNE	R2, R0, L__OS_StartTask_Delay389
NOP	
J	L__OS_StartTask_Delay157
NOP	
L__OS_StartTask_Delay389:
J	L_end__OS_StartTask_Delay
NOP	
L__OS_StartTask_Delay157:
;RTOS.mpas,852 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,854 :: 		if (TaskData[TaskID]._State = st_STOPPED) then
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 144
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__OS_StartTask_Delay390
NOP	
J	L__OS_StartTask_Delay160
NOP	
L__OS_StartTask_Delay390:
;RTOS.mpas,856 :: 		TaskData[TaskID]._State := st_DELAYED; // task is st_DELAYED for a while before starting
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 144
ORI	R2, R0, 2
SB	R2, 0(R3)
;RTOS.mpas,857 :: 		TaskData[TaskID]._Timer := Ticks;
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 146
SH	R26, 0(R2)
;RTOS.mpas,858 :: 		end;
L__OS_StartTask_Delay160:
;RTOS.mpas,860 :: 		if Ticks < IntTime then
ANDI	R2, R26, 65535
SLTIU	R2, R2, 10
BNE	R2, R0, L__OS_StartTask_Delay391
NOP	
J	L__OS_StartTask_Delay163
NOP	
L__OS_StartTask_Delay391:
;RTOS.mpas,862 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,863 :: 		T1IF_bit := 1;
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+8), 4
;RTOS.mpas,864 :: 		end;
L__OS_StartTask_Delay163:
;RTOS.mpas,867 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,868 :: 		end;
L_end__OS_StartTask_Delay:
L_end_OS_StartTask_Delay:
JR	RA
NOP	
; end of _OS_StartTask_Delay
_OS_StopTask:
;RTOS.mpas,872 :: 		begin
;RTOS.mpas,873 :: 		if TaskID > LastTask then exit; // not a valid TaskId
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R2, R2, R3
BNE	R2, R0, L__OS_StopTask393
NOP	
J	L__OS_StopTask167
NOP	
L__OS_StopTask393:
J	L_end__OS_StopTask
NOP	
L__OS_StopTask167:
;RTOS.mpas,876 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,878 :: 		if TaskData[TaskId]._State >= st_STOPPED then TaskData[TaskID]._State := st_STOPPED; // stop the task
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 144
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLTIU	R2, R2, 1
BEQ	R2, R0, L__OS_StopTask394
NOP	
J	L__OS_StopTask170
NOP	
L__OS_StopTask394:
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 144
ORI	R2, R0, 1
SB	R2, 0(R3)
L__OS_StopTask170:
;RTOS.mpas,880 :: 		if TaskID = CurrentTask then
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_CurrentTask+0)(GP)
BEQ	R3, R2, L__OS_StopTask395
NOP	
J	L__OS_StopTask173
NOP	
L__OS_StopTask395:
;RTOS.mpas,882 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,883 :: 		T1IF_bit := 1;
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+8), 4
;RTOS.mpas,884 :: 		end;
L__OS_StopTask173:
;RTOS.mpas,887 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,888 :: 		end;
L_end__OS_StopTask:
L_end_OS_StopTask:
JR	RA
NOP	
; end of _OS_StopTask
_OS_ReplaceTask:
;RTOS.mpas,891 :: 		begin
;RTOS.mpas,892 :: 		if (TaskID > LastTask) or      // not a valid TaskID
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R4, R2, R3
BEQ	R4, R0, L__OS_ReplaceTask398
NOP	
ADDIU	R4, R0, -1
L__OS_ReplaceTask398:
;RTOS.mpas,893 :: 		(TaskID = CurrentTask) or      // can not replace a task by itself
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_CurrentTask+0)(GP)
XOR	R2, R3, R2
SLTIU	R2, R2, 1
BEQ	R2, R0, L__OS_ReplaceTask400
NOP	
ADDIU	R2, R0, -1
L__OS_ReplaceTask400:
OR	R3, R4, R2
;RTOS.mpas,894 :: 		(CurrentTask = OS_NO_TASK) then exit;
LBU	R2, Offset(RTOS_CurrentTask+0)(GP)
XORI	R2, R2, 255
SLTIU	R2, R2, 1
BEQ	R2, R0, L__OS_ReplaceTask402
NOP	
ADDIU	R2, R0, -1
L__OS_ReplaceTask402:
OR	R2, R3, R2
BNE	R2, R0, L__OS_ReplaceTask404
NOP	
J	L__OS_ReplaceTask177
NOP	
L__OS_ReplaceTask404:
J	L_end__OS_ReplaceTask
NOP	
L__OS_ReplaceTask177:
;RTOS.mpas,897 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,899 :: 		TaskData[CurrentTask]._State := st_STOPPED; // stop the current task
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 144
ORI	R2, R0, 1
SB	R2, 0(R3)
;RTOS.mpas,900 :: 		if (TaskData[TaskID]._State = st_STOPPED) then Taskdata[TaskID]._State := st_ELIGIBLE; // start the new task
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 144
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__OS_ReplaceTask405
NOP	
J	L__OS_ReplaceTask180
NOP	
L__OS_ReplaceTask405:
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 144
ORI	R2, R0, 4
SB	R2, 0(R3)
L__OS_ReplaceTask180:
;RTOS.mpas,902 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,903 :: 		T1IF_bit  := 1;
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+8), 4
;RTOS.mpas,906 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,907 :: 		end;
L_end__OS_ReplaceTask:
L_end_OS_ReplaceTask:
JR	RA
NOP	
; end of _OS_ReplaceTask
_OS_CurrentTask:
;RTOS.mpas,910 :: 		begin
;RTOS.mpas,912 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,914 :: 		Result := CurrentTask;
; Result start address is: 12 (R3)
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
;RTOS.mpas,917 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,918 :: 		end;
ANDI	R2, R3, 255
; Result end address is: 12 (R3)
L_end_OS_CurrentTask:
JR	RA
NOP	
; end of _OS_CurrentTask
_OS_CreateBinarySemaphore:
;RTOS.mpas,922 :: 		begin
;RTOS.mpas,923 :: 		Result := OS_NO_EVENT; // no free event found
; Result start address is: 16 (R4)
ORI	R4, R0, 255
;RTOS.mpas,925 :: 		if LastEvent = (OS_EVENTS_COUNT - 1) then exit; // no unused events available any more
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
ORI	R2, R0, 9
BEQ	R3, R2, L__OS_CreateBinarySemaphore408
NOP	
J	L__OS_CreateBinarySemaphore185
NOP	
L__OS_CreateBinarySemaphore408:
ANDI	R3, R4, 255
; Result end address is: 16 (R4)
J	L_end__OS_CreateBinarySemaphore
NOP	
L__OS_CreateBinarySemaphore185:
;RTOS.mpas,927 :: 		if LastEvent = OS_NO_EVENT
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
ORI	R2, R0, 255
BEQ	R3, R2, L__OS_CreateBinarySemaphore409
NOP	
J	L__OS_CreateBinarySemaphore188
NOP	
L__OS_CreateBinarySemaphore409:
;RTOS.mpas,928 :: 		then LastEvent := 0
SB	R0, Offset(RTOS_LastEvent+0)(GP)
J	L__OS_CreateBinarySemaphore189
NOP	
;RTOS.mpas,929 :: 		else inc(LastEvent);
L__OS_CreateBinarySemaphore188:
LBU	R2, Offset(RTOS_LastEvent+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_LastEvent+0)(GP)
L__OS_CreateBinarySemaphore189:
;RTOS.mpas,931 :: 		Result := LastEvent;
; Result start address is: 16 (R4)
LBU	R4, Offset(RTOS_LastEvent+0)(GP)
;RTOS.mpas,933 :: 		with EventData[LastEvent] do
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R3, R2, R3
; indwith??T602 start address is: 20 (R5)
MOVZ	R5, R3, R0
;RTOS.mpas,935 :: 		_Type := et_BINARY;
ORI	R2, R0, 2
SB	R2, 0(R3)
;RTOS.mpas,936 :: 		if InitialValue
BNE	R25, R0, L__OS_CreateBinarySemaphore411
NOP	
J	L__OS_CreateBinarySemaphore191
NOP	
L__OS_CreateBinarySemaphore411:
;RTOS.mpas,937 :: 		then _SemCount := 1
ADDIU	R3, R5, 2
ORI	R2, R0, 1
SH	R2, 0(R3)
J	L__OS_CreateBinarySemaphore192
NOP	
;RTOS.mpas,938 :: 		else _SemCount := 0;
L__OS_CreateBinarySemaphore191:
ADDIU	R2, R5, 2
SH	R0, 0(R2)
L__OS_CreateBinarySemaphore192:
;RTOS.mpas,940 :: 		_SemISR := 0;
ADDIU	R2, R5, 4
; indwith??T602 end address is: 20 (R5)
SH	R0, 0(R2)
; Result end address is: 16 (R4)
ANDI	R3, R4, 255
;RTOS.mpas,943 :: 		end;
L_end__OS_CreateBinarySemaphore:
; Result start address is: 12 (R3)
ANDI	R2, R3, 255
; Result end address is: 12 (R3)
L_end_OS_CreateBinarySemaphore:
JR	RA
NOP	
; end of _OS_CreateBinarySemaphore
_OS_CreateCountingSemaphore:
;RTOS.mpas,946 :: 		begin
;RTOS.mpas,947 :: 		Result := OS_NO_EVENT; // no free event found
; Result start address is: 16 (R4)
ORI	R4, R0, 255
;RTOS.mpas,949 :: 		if LastEvent = (OS_EVENTS_COUNT - 1) then exit; // no unused events available any more
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
ORI	R2, R0, 9
BEQ	R3, R2, L__OS_CreateCountingSemaphore413
NOP	
J	L__OS_CreateCountingSemaphore195
NOP	
L__OS_CreateCountingSemaphore413:
ANDI	R3, R4, 255
; Result end address is: 16 (R4)
J	L_end__OS_CreateCountingSemaphore
NOP	
L__OS_CreateCountingSemaphore195:
;RTOS.mpas,951 :: 		if LastEvent = OS_NO_EVENT
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
ORI	R2, R0, 255
BEQ	R3, R2, L__OS_CreateCountingSemaphore414
NOP	
J	L__OS_CreateCountingSemaphore198
NOP	
L__OS_CreateCountingSemaphore414:
;RTOS.mpas,952 :: 		then LastEvent := 0
SB	R0, Offset(RTOS_LastEvent+0)(GP)
J	L__OS_CreateCountingSemaphore199
NOP	
;RTOS.mpas,953 :: 		else inc(LastEvent);
L__OS_CreateCountingSemaphore198:
LBU	R2, Offset(RTOS_LastEvent+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(RTOS_LastEvent+0)(GP)
L__OS_CreateCountingSemaphore199:
;RTOS.mpas,955 :: 		Result := LastEvent;
; Result start address is: 16 (R4)
LBU	R4, Offset(RTOS_LastEvent+0)(GP)
;RTOS.mpas,957 :: 		with EventData[LastEvent] do
LBU	R3, Offset(RTOS_LastEvent+0)(GP)
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R3, R2, R3
; indwith??T623 start address is: 20 (R5)
MOVZ	R5, R3, R0
;RTOS.mpas,959 :: 		_Type := et_COUNTING;
ORI	R2, R0, 3
SB	R2, 0(R3)
;RTOS.mpas,960 :: 		_SemCount := InitialValue;
ADDIU	R2, R5, 2
SH	R25, 0(R2)
;RTOS.mpas,962 :: 		_SemISR := 0;
ADDIU	R2, R5, 4
; indwith??T623 end address is: 20 (R5)
SH	R0, 0(R2)
; Result end address is: 16 (R4)
ANDI	R3, R4, 255
;RTOS.mpas,965 :: 		end;
L_end__OS_CreateCountingSemaphore:
; Result start address is: 12 (R3)
ANDI	R2, R3, 255
; Result end address is: 12 (R3)
L_end_OS_CreateCountingSemaphore:
JR	RA
NOP	
; end of _OS_CreateCountingSemaphore
_OS_TaskRunning:
;RTOS.mpas,969 :: 		begin
;RTOS.mpas,971 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,973 :: 		Result := st_DESTROYED;
; Result start address is: 16 (R4)
MOVZ	R4, R0, R0
;RTOS.mpas,974 :: 		if TaskID <= LastTask then Result := TaskData[TaskID]._State > st_STOPPED;
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R2, R2, R3
BEQ	R2, R0, L__OS_TaskRunning416
NOP	
J	L__OS_TaskRunning285
NOP	
L__OS_TaskRunning416:
; Result end address is: 16 (R4)
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 144
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLTIU	R2, R2, 2
XORI	R2, R2, 1
BEQ	R2, R0, L__OS_TaskRunning418
NOP	
ADDIU	R2, R0, -1
L__OS_TaskRunning418:
; Result start address is: 12 (R3)
MOVZ	R3, R2, R0
; Result end address is: 12 (R3)
J	L__OS_TaskRunning202
NOP	
L__OS_TaskRunning285:
MOVZ	R3, R4, R0
L__OS_TaskRunning202:
;RTOS.mpas,977 :: 		OS_Timer_IE_bit := 1;
; Result start address is: 12 (R3)
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,978 :: 		end;
MOVZ	R2, R3, R0
; Result end address is: 12 (R3)
L_end_OS_TaskRunning:
JR	RA
NOP	
; end of _OS_TaskRunning
_OS_Yield:
;RTOS.mpas,982 :: 		begin
;RTOS.mpas,983 :: 		if (CurrentTask = OS_NO_TASK) then exit;
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 255
BEQ	R3, R2, L__OS_Yield420
NOP	
J	L__OS_Yield206
NOP	
L__OS_Yield420:
J	L_end__OS_Yield
NOP	
L__OS_Yield206:
;RTOS.mpas,985 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,987 :: 		TaskData[CurrentTask]._State := st_ELIGIBLE; // task is no longer st_RUNNING
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 144
ORI	R2, R0, 4
SB	R2, 0(R3)
;RTOS.mpas,988 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,989 :: 		T1IF_bit  := 1;
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+8), 4
;RTOS.mpas,991 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,992 :: 		end;
L_end__OS_Yield:
L_end_OS_Yield:
JR	RA
NOP	
; end of _OS_Yield
_OS_Delay:
;RTOS.mpas,997 :: 		begin
;RTOS.mpas,998 :: 		if (CurrentTask = OS_NO_TASK) then exit;
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 255
BEQ	R3, R2, L__OS_Delay422
NOP	
J	L__OS_Delay210
NOP	
L__OS_Delay422:
J	L_end__OS_Delay
NOP	
L__OS_Delay210:
;RTOS.mpas,1000 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1002 :: 		TaskData[CurrentTask]._State := st_DELAYED; // task is st_DELAYED for a while
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 144
ORI	R2, R0, 2
SB	R2, 0(R3)
;RTOS.mpas,1003 :: 		TaskData[CurrentTask]._Timer := Ticks;
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 146
SH	R25, 0(R2)
;RTOS.mpas,1004 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,1005 :: 		T1IF_bit    := 1;  // Immediate action required
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+8), 4
;RTOS.mpas,1007 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,1008 :: 		end;
L_end__OS_Delay:
L_end_OS_Delay:
JR	RA
NOP	
; end of _OS_Delay
_OS_SignalSemaphore:
;RTOS.mpas,1013 :: 		begin
;RTOS.mpas,1014 :: 		if Event_ <> OS_NO_EVENT then
ANDI	R3, R25, 255
ORI	R2, R0, 255
BNE	R3, R2, L__OS_SignalSemaphore425
NOP	
J	L__OS_SignalSemaphore214
NOP	
L__OS_SignalSemaphore425:
;RTOS.mpas,1016 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1018 :: 		if EventData[Event_]._Type = et_Binary
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 2
BEQ	R3, R2, L__OS_SignalSemaphore426
NOP	
J	L__OS_SignalSemaphore217
NOP	
L__OS_SignalSemaphore426:
;RTOS.mpas,1019 :: 		then EventData[Event_]._SemCount := 1
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 2
ORI	R2, R0, 1
SH	R2, 0(R3)
J	L__OS_SignalSemaphore218
NOP	
;RTOS.mpas,1020 :: 		else inc(EventData[Event_]._SemCount);
L__OS_SignalSemaphore217:
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 2
LHU	R2, 0(R3)
ADDIU	R2, R2, 1
SH	R2, 0(R3)
L__OS_SignalSemaphore218:
;RTOS.mpas,1022 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,1023 :: 		end;
L__OS_SignalSemaphore214:
;RTOS.mpas,1024 :: 		end;
L_end_OS_SignalSemaphore:
JR	RA
NOP	
; end of _OS_SignalSemaphore
_OS_ClearSemaphore:
;RTOS.mpas,1027 :: 		begin
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;RTOS.mpas,1028 :: 		if Event_ <> OS_NO_EVENT then
SW	R25, 4(SP)
ANDI	R3, R25, 255
ORI	R2, R0, 255
BNE	R3, R2, L__OS_ClearSemaphore429
NOP	
J	L__OS_ClearSemaphore221
NOP	
L__OS_ClearSemaphore429:
;RTOS.mpas,1030 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1032 :: 		EventData[Event_]._SemCount := 0;
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 2
SH	R0, 0(R2)
;RTOS.mpas,1038 :: 		InterruptState := DisableInterrupts;
DI	R30
SW	R30, Offset(RTOS_InterruptState+0)(GP)
;RTOS.mpas,1040 :: 		EventData[Event_]._SemISR := 0;
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 4
SH	R0, 0(R2)
;RTOS.mpas,1043 :: 		RestoreInterrupts(InterruptState);
LW	R25, Offset(RTOS_InterruptState+0)(GP)
JAL	_RestoreInterrupts+0
NOP	
;RTOS.mpas,1047 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,1048 :: 		end;
L__OS_ClearSemaphore221:
;RTOS.mpas,1049 :: 		end;
L_end_OS_ClearSemaphore:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _OS_ClearSemaphore
_OS_SignalSemaphore_ISR:
;RTOS.mpas,1053 :: 		begin
;RTOS.mpas,1055 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1057 :: 		if Event_ <> OS_NO_EVENT then inc(EventData[Event_]._SemISR);
ANDI	R3, R25, 255
ORI	R2, R0, 255
BNE	R3, R2, L__OS_SignalSemaphore_ISR432
NOP	
J	L__OS_SignalSemaphore_ISR225
NOP	
L__OS_SignalSemaphore_ISR432:
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 4
LHU	R2, 0(R3)
ADDIU	R2, R2, 1
SH	R2, 0(R3)
L__OS_SignalSemaphore_ISR225:
;RTOS.mpas,1060 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,1061 :: 		end;
L_end_OS_SignalSemaphore_ISR:
JR	RA
NOP	
; end of _OS_SignalSemaphore_ISR
_OS_WaitSemaphore:
;RTOS.mpas,1069 :: 		begin
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;RTOS.mpas,1070 :: 		if (CurrentTask = OS_NO_TASK) or
LBU	R2, Offset(RTOS_CurrentTask+0)(GP)
XORI	R3, R2, 255
SLTIU	R3, R3, 1
BEQ	R3, R0, L__OS_WaitSemaphore435
NOP	
ADDIU	R3, R0, -1
L__OS_WaitSemaphore435:
;RTOS.mpas,1071 :: 		(Event_ = OS_NO_EVENT) then exit; // semaphore does no exist
ANDI	R2, R25, 255
XORI	R2, R2, 255
SLTIU	R2, R2, 1
BEQ	R2, R0, L__OS_WaitSemaphore437
NOP	
ADDIU	R2, R0, -1
L__OS_WaitSemaphore437:
OR	R2, R3, R2
BNE	R2, R0, L__OS_WaitSemaphore439
NOP	
J	L__OS_WaitSemaphore229
NOP	
L__OS_WaitSemaphore439:
J	L_end__OS_WaitSemaphore
NOP	
L__OS_WaitSemaphore229:
;RTOS.mpas,1074 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1077 :: 		TaskData[CurrentTask]._Misc.mi_TIMEOUT_bit := 0; // clear timeout flag
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 149
LBU	R2, 0(R3)
INS	R2, R0, 0, 1
SB	R2, 0(R3)
;RTOS.mpas,1081 :: 		Check_Events_ISR; // get the events submitted in ISR and copy then to the actual EventData
JAL	RTOS_Check_Events_ISR+0
NOP	
;RTOS.mpas,1084 :: 		if EventData[Event_]._SemCount > 0 then // task can be continued immediately
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 2
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 1
BEQ	R2, R0, L__OS_WaitSemaphore440
NOP	
J	L__OS_WaitSemaphore232
NOP	
L__OS_WaitSemaphore440:
;RTOS.mpas,1086 :: 		dec(EventData[Event_]._SemCount);
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 2
LHU	R2, 0(R3)
ADDIU	R2, R2, -1
SH	R2, 0(R3)
;RTOS.mpas,1087 :: 		end
J	L__OS_WaitSemaphore233
NOP	
;RTOS.mpas,1088 :: 		else
L__OS_WaitSemaphore232:
;RTOS.mpas,1091 :: 		TaskData[CurrentTask]._EventID := Event_;
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 148
SB	R25, 0(R2)
;RTOS.mpas,1092 :: 		TaskData[CurrentTask]._State   := st_WAITING;
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 144
ORI	R2, R0, 3
SB	R2, 0(R3)
;RTOS.mpas,1094 :: 		TaskData[CurrentTask]._Timer   := TimeOut;
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 146
SH	R26, 0(R2)
;RTOS.mpas,1098 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,1099 :: 		T1IF_bit  := 1;
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+8), 4
;RTOS.mpas,1100 :: 		end;
L__OS_WaitSemaphore233:
;RTOS.mpas,1103 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,1104 :: 		end;
L_end__OS_WaitSemaphore:
L_end_OS_WaitSemaphore:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _OS_WaitSemaphore
_OS_TimeOut:
;RTOS.mpas,1108 :: 		begin
;RTOS.mpas,1109 :: 		Result := false;
; Result start address is: 16 (R4)
MOVZ	R4, R0, R0
;RTOS.mpas,1111 :: 		if (CurrentTask = OS_NO_TASK) then exit;
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 255
BEQ	R3, R2, L__OS_TimeOut442
NOP	
J	L__OS_TimeOut236
NOP	
L__OS_TimeOut442:
MOVZ	R3, R4, R0
; Result end address is: 16 (R4)
J	L_end__OS_TimeOut
NOP	
L__OS_TimeOut236:
;RTOS.mpas,1114 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1116 :: 		Result := TaskData[CurrentTask]._Misc.mi_TIMEOUT_bit = 1; // timeout flag was set
LBU	R3, Offset(RTOS_CurrentTask+0)(GP)
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 149
LBU	R2, 0(R2)
EXT	R2, R2, 0, 1
ANDI	R2, R2, 255
XORI	R2, R2, 1
SLTIU	R2, R2, 1
BEQ	R2, R0, L__OS_TimeOut444
NOP	
ADDIU	R2, R0, -1
L__OS_TimeOut444:
; Result start address is: 16 (R4)
MOVZ	R4, R2, R0
;RTOS.mpas,1117 :: 		TaskData[CurrentTask]._Misc.mi_TIMEOUT_Bit := 0;          // clear the flag
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 149
LBU	R2, 0(R3)
INS	R2, R0, 0, 1
SB	R2, 0(R3)
;RTOS.mpas,1120 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
; Result end address is: 16 (R4)
MOVZ	R3, R4, R0
;RTOS.mpas,1121 :: 		end;
L_end__OS_TimeOut:
; Result start address is: 12 (R3)
MOVZ	R2, R3, R0
; Result end address is: 12 (R3)
L_end_OS_TimeOut:
JR	RA
NOP	
; end of _OS_TimeOut
_OS_ReadSemaphore:
;RTOS.mpas,1125 :: 		begin
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;RTOS.mpas,1126 :: 		Result := false;
; Result start address is: 16 (R4)
MOVZ	R4, R0, R0
;RTOS.mpas,1127 :: 		if Event_ <= LastEvent then
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastEvent+0)(GP)
SLTU	R2, R2, R3
BEQ	R2, R0, L__OS_ReadSemaphore446
NOP	
J	L__OS_ReadSemaphore286
NOP	
L__OS_ReadSemaphore446:
; Result end address is: 16 (R4)
;RTOS.mpas,1130 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1133 :: 		Check_Events_ISR; // get the events submitted in ISR and copy then to the actual EventData
JAL	RTOS_Check_Events_ISR+0
NOP	
;RTOS.mpas,1136 :: 		Result := EventData[Event_]._SemCount > 0;
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 2
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 1
XORI	R2, R2, 1
BEQ	R2, R0, L__OS_ReadSemaphore448
NOP	
ADDIU	R2, R0, -1
L__OS_ReadSemaphore448:
; Result start address is: 12 (R3)
MOVZ	R3, R2, R0
;RTOS.mpas,1139 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
; Result end address is: 12 (R3)
;RTOS.mpas,1140 :: 		end;
J	L__OS_ReadSemaphore240
NOP	
L__OS_ReadSemaphore286:
;RTOS.mpas,1127 :: 		if Event_ <= LastEvent then
MOVZ	R3, R4, R0
;RTOS.mpas,1140 :: 		end;
L__OS_ReadSemaphore240:
;RTOS.mpas,1141 :: 		end;
; Result start address is: 12 (R3)
MOVZ	R2, R3, R0
; Result end address is: 12 (R3)
L_end_OS_ReadSemaphore:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _OS_ReadSemaphore
_OS_ReadCountingSemaphore:
;RTOS.mpas,1144 :: 		begin
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;RTOS.mpas,1145 :: 		Result := 0;
; Result start address is: 16 (R4)
MOVZ	R4, R0, R0
;RTOS.mpas,1146 :: 		if Event_ <= LastEvent then
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastEvent+0)(GP)
SLTU	R2, R2, R3
BEQ	R2, R0, L__OS_ReadCountingSemaphore450
NOP	
J	L__OS_ReadCountingSemaphore287
NOP	
L__OS_ReadCountingSemaphore450:
; Result end address is: 16 (R4)
;RTOS.mpas,1149 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1152 :: 		Check_Events_ISR; // get the events submitted in ISR and copy then to the actual EventData
JAL	RTOS_Check_Events_ISR+0
NOP	
;RTOS.mpas,1155 :: 		Result := EventData[Event_]._SemCount;
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 2
LHU	R2, 0(R2)
; Result start address is: 12 (R3)
ANDI	R3, R2, 65535
;RTOS.mpas,1158 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
; Result end address is: 12 (R3)
;RTOS.mpas,1159 :: 		end;
J	L__OS_ReadCountingSemaphore244
NOP	
L__OS_ReadCountingSemaphore287:
;RTOS.mpas,1146 :: 		if Event_ <= LastEvent then
ANDI	R3, R4, 65535
;RTOS.mpas,1159 :: 		end;
L__OS_ReadCountingSemaphore244:
;RTOS.mpas,1160 :: 		end;
; Result start address is: 12 (R3)
ANDI	R2, R3, 65535
; Result end address is: 12 (R3)
L_end_OS_ReadCountingSemaphore:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _OS_ReadCountingSemaphore
_OS_TrySemaphore:
;RTOS.mpas,1163 :: 		begin
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;RTOS.mpas,1164 :: 		Result := false;
; Result start address is: 16 (R4)
MOVZ	R4, R0, R0
;RTOS.mpas,1165 :: 		if Event_ <= LastEvent then
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastEvent+0)(GP)
SLTU	R2, R2, R3
BEQ	R2, R0, L__OS_TrySemaphore452
NOP	
J	L__OS_TrySemaphore288
NOP	
L__OS_TrySemaphore452:
; Result end address is: 16 (R4)
;RTOS.mpas,1168 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1171 :: 		Check_Events_ISR; // get the events submitted in ISR and copy then to the actual EventData
JAL	RTOS_Check_Events_ISR+0
NOP	
;RTOS.mpas,1174 :: 		Result := EventData[Event_]._SemCount > 0;
ANDI	R3, R25, 255
ORI	R2, R0, 6
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_EventData+0)
ORI	R2, R2, #lo_addr(RTOS_EventData+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 2
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 1
XORI	R2, R2, 1
BEQ	R2, R0, L__OS_TrySemaphore454
NOP	
ADDIU	R2, R0, -1
L__OS_TrySemaphore454:
; Result start address is: 12 (R3)
MOVZ	R3, R2, R0
;RTOS.mpas,1177 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
; Result end address is: 12 (R3)
;RTOS.mpas,1178 :: 		end;
J	L__OS_TrySemaphore248
NOP	
L__OS_TrySemaphore288:
;RTOS.mpas,1165 :: 		if Event_ <= LastEvent then
MOVZ	R3, R4, R0
;RTOS.mpas,1178 :: 		end;
L__OS_TrySemaphore248:
;RTOS.mpas,1179 :: 		end;
; Result start address is: 12 (R3)
MOVZ	R2, R3, R0
; Result end address is: 12 (R3)
L_end_OS_TrySemaphore:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _OS_TrySemaphore
_OS_SetPriority:
;RTOS.mpas,1184 :: 		begin
;RTOS.mpas,1186 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1188 :: 		if Priority >= OS_PRIORITY_COUNT then Priority := (OS_PRIORITY_COUNT -1);
ANDI	R2, R26, 255
SLTIU	R2, R2, 10
BEQ	R2, R0, L__OS_SetPriority456
NOP	
J	L__OS_SetPriority252
NOP	
L__OS_SetPriority456:
ORI	R26, R0, 9
L__OS_SetPriority252:
;RTOS.mpas,1189 :: 		if Priority > LowestPriority then LowestPriority := Priority;
ANDI	R3, R26, 255
LBU	R2, Offset(RTOS_LowestPriority+0)(GP)
SLTU	R2, R2, R3
BNE	R2, R0, L__OS_SetPriority457
NOP	
J	L__OS_SetPriority255
NOP	
L__OS_SetPriority457:
SB	R26, Offset(RTOS_LowestPriority+0)(GP)
L__OS_SetPriority255:
;RTOS.mpas,1190 :: 		if TaskID <= LastTask then
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R2, R2, R3
BEQ	R2, R0, L__OS_SetPriority458
NOP	
J	L__OS_SetPriority258
NOP	
L__OS_SetPriority458:
;RTOS.mpas,1192 :: 		TaskData[TaskID]._Priority := Priority;
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 145
SB	R26, 0(R2)
;RTOS.mpas,1195 :: 		Immediate := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,1196 :: 		T1IF_bit  := 1;
LUI	R2, BitMask(T1IF_bit+0)
ORI	R2, R2, BitMask(T1IF_bit+0)
_SX	8, Offset(T1IF_bit+8), 4
;RTOS.mpas,1197 :: 		end;
L__OS_SetPriority258:
;RTOS.mpas,1200 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,1201 :: 		end;
L_end_OS_SetPriority:
JR	RA
NOP	
; end of _OS_SetPriority
_OS_Priority:
;RTOS.mpas,1204 :: 		begin
;RTOS.mpas,1205 :: 		Result := (OS_PRIORITY_COUNT -1); // lowest priority
; Result start address is: 16 (R4)
ORI	R4, R0, 9
;RTOS.mpas,1206 :: 		if TaskID <= LastTask then Result := TaskData[TaskID]._Priority;
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R2, R2, R3
BEQ	R2, R0, L__OS_Priority460
NOP	
J	L__OS_Priority289
NOP	
L__OS_Priority460:
; Result end address is: 16 (R4)
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 145
LBU	R2, 0(R2)
; Result start address is: 12 (R3)
ANDI	R3, R2, 255
; Result end address is: 12 (R3)
J	L__OS_Priority262
NOP	
L__OS_Priority289:
ANDI	R3, R4, 255
L__OS_Priority262:
;RTOS.mpas,1207 :: 		end;
; Result start address is: 12 (R3)
ANDI	R2, R3, 255
; Result end address is: 12 (R3)
L_end_OS_Priority:
JR	RA
NOP	
; end of _OS_Priority
_OS_TaskState:
;RTOS.mpas,1211 :: 		begin
;RTOS.mpas,1213 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1215 :: 		Result := st_DESTROYED;
; Result start address is: 16 (R4)
MOVZ	R4, R0, R0
;RTOS.mpas,1216 :: 		if TaskID <= LastTask then Result := TaskData[TaskID]._State;
ANDI	R3, R25, 255
LBU	R2, Offset(RTOS_LastTask+0)(GP)
SLTU	R2, R2, R3
BEQ	R2, R0, L__OS_TaskState462
NOP	
J	L__OS_TaskState290
NOP	
L__OS_TaskState462:
; Result end address is: 16 (R4)
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 144
LBU	R2, 0(R2)
; Result start address is: 12 (R3)
ANDI	R3, R2, 255
; Result end address is: 12 (R3)
J	L__OS_TaskState266
NOP	
L__OS_TaskState290:
ANDI	R3, R4, 255
L__OS_TaskState266:
;RTOS.mpas,1219 :: 		OS_Timer_IE_bit := 1;
; Result start address is: 12 (R3)
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,1220 :: 		end;
ANDI	R2, R3, 255
; Result end address is: 12 (R3)
L_end_OS_TaskState:
JR	RA
NOP	
; end of _OS_TaskState
_OS_Stack_Usage:
;RTOS.mpas,1224 :: 		begin
ADDIU	SP, SP, -4
;RTOS.mpas,1225 :: 		if TaskID = OS_NO_TASK then exit;
ANDI	R3, R25, 255
ORI	R2, R0, 255
BEQ	R3, R2, L__OS_Stack_Usage464
NOP	
J	L__OS_Stack_Usage270
NOP	
L__OS_Stack_Usage464:
J	L_end__OS_Stack_Usage
NOP	
L__OS_Stack_Usage270:
;RTOS.mpas,1228 :: 		OS_Timer_IE_bit := 0;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+4), 4
;RTOS.mpas,1230 :: 		Result := TaskData[TaskID]._StackUsage;
ANDI	R3, R25, 255
ORI	R2, R0, 160
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(RTOS_Taskdata+0)
ORI	R2, R2, #lo_addr(RTOS_Taskdata+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 156
LBU	R2, 0(R2)
SB	R2, 0(SP)
;RTOS.mpas,1233 :: 		OS_Timer_IE_bit := 1;
LUI	R2, BitMask(T1IE_bit+0)
ORI	R2, R2, BitMask(T1IE_bit+0)
_SX	8, Offset(T1IE_bit+8), 4
;RTOS.mpas,1234 :: 		end;
L_end__OS_Stack_Usage:
LBU	R2, 0(SP)
L_end_OS_Stack_Usage:
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _OS_Stack_Usage
RTOS_IdleRoutine:
;RTOS.mpas,1238 :: 		begin
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;RTOS.mpas,1239 :: 		while true do
L_RTOS_IdleRoutine274:
;RTOS.mpas,1242 :: 		if OS_Idleprocedure <> nil then OS_Idleprocedure^; // call the idle procedure (if any)
LW	R2, Offset(_OS_IdleProcedure+0)(GP)
BNE	R2, R0, L_RTOS_IdleRoutine467
NOP	
J	L_RTOS_IdleRoutine279
NOP	
L_RTOS_IdleRoutine467:
LW	R30, Offset(_OS_IdleProcedure+0)(GP)
JALR	RA, R30
NOP	
L_RTOS_IdleRoutine279:
;RTOS.mpas,1244 :: 		end;
J	L_RTOS_IdleRoutine274
NOP	
;RTOS.mpas,1245 :: 		end;
L_end_IdleRoutine:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of RTOS_IdleRoutine
_OS_Run:
;RTOS.mpas,1250 :: 		begin
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;RTOS.mpas,1253 :: 		GetMemAlign(OS_Run_MemPtr, OS_Task_StackSize + 4, 4);
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
ORI	R27, R0, 4
ORI	R26, R0, 104
LUI	R25, #hi_addr(RTOS_OS_Run_MemPtr+0)
ORI	R25, R25, #lo_addr(RTOS_OS_Run_MemPtr+0)
JAL	_GetMemAlign+0
NOP	
;RTOS.mpas,1254 :: 		if OS_Run_MemPtr = nil then  // no stack memory available
LW	R2, Offset(RTOS_OS_Run_MemPtr+0)(GP)
BEQ	R2, R0, L__OS_Run469
NOP	
J	L__OS_Run283
NOP	
L__OS_Run469:
;RTOS.mpas,1257 :: 		OS_Idleprocedure := nil;
SW	R0, Offset(_OS_IdleProcedure+0)(GP)
;RTOS.mpas,1258 :: 		OS_Run_MemPtr := ^byte(SP - 100);
ADDIU	R2, SP, -100
SW	R2, Offset(RTOS_OS_Run_MemPtr+0)(GP)
;RTOS.mpas,1260 :: 		end;
L__OS_Run283:
;RTOS.mpas,1265 :: 		_State := st_STOPPED;
ORI	R2, R0, 1
SB	R2, Offset(RTOS_IdleData+144)(GP)
;RTOS.mpas,1267 :: 		_Misc := 0;                                                  // set all bits to zero
SB	R0, Offset(RTOS_IdleData+149)(GP)
;RTOS.mpas,1270 :: 		_StackBase  := dword(Create_Task_MemPtr);
LW	R2, Offset(RTOS_Create_Task_MemPtr+0)(GP)
SW	R2, Offset(RTOS_IdleData+152)(GP)
;RTOS.mpas,1271 :: 		_StackUsage := 0;
SB	R0, Offset(RTOS_IdleData+156)(GP)
;RTOS.mpas,1272 :: 		memset(OS_Run_MemPtr, 0, OS_Task_StackSize + 4);
ORI	R27, R0, 104
MOVZ	R26, R0, R0
LW	R25, Offset(RTOS_OS_Run_MemPtr+0)(GP)
JAL	_memset+0
NOP	
;RTOS.mpas,1275 :: 		Regs[1] := GP;                                               // global pointer to global variables
SW	GP, Offset(RTOS_IdleData+4)(GP)
;RTOS.mpas,1276 :: 		Regs[29] := dword(OS_Run_MemPtr) + OS_Task_StackSize;        // initial stackpointer = Top of Stack
LW	R2, Offset(RTOS_OS_Run_MemPtr+0)(GP)
ADDIU	R2, R2, 100
SW	R2, Offset(RTOS_IdleData+116)(GP)
;RTOS.mpas,1277 :: 		RetAddr := Dword(@IdleRoutine);                              // store return address
LUI	R2, #hi_addr(RTOS_IdleRoutine+0)
ORI	R2, R2, #lo_addr(RTOS_IdleRoutine+0)
SW	R2, Offset(RTOS_IdleData+128)(GP)
;RTOS.mpas,1280 :: 		MFHI R30
MFHI	R30
;RTOS.mpas,1282 :: 		HiVal := R30;
SW	R30, Offset(RTOS_IdleData+132)(GP)
;RTOS.mpas,1285 :: 		MFLO R30
MFLO	R30
;RTOS.mpas,1287 :: 		LoVal := R30;
SW	R30, Offset(RTOS_IdleData+136)(GP)
;RTOS.mpas,1290 :: 		MFC0        R30, 12, 0
MFC0	R30, 12, 0
;RTOS.mpas,1292 :: 		Status_ := R30 or 1; // set interrupt enable
ORI	R2, R30, 1
SW	R2, Offset(RTOS_IdleData+140)(GP)
;RTOS.mpas,1295 :: 		IdleRunning := false;
SW	R0, Offset(RTOS_IdleRunning+0)(GP)
;RTOS.mpas,1296 :: 		Immediate := false;
SW	R0, Offset(RTOS_Immediate+0)(GP)
;RTOS.mpas,1297 :: 		OS_Count := 0;
SB	R0, Offset(RTOS_OS_Count+0)(GP)
;RTOS.mpas,1298 :: 		InitTimer1;
JAL	_InitTimer1+0
NOP	
;RTOS.mpas,1299 :: 		end;
L_end_OS_Run:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _OS_Run
